#
# Atom, Literal and Rule classes
#
# Orkunt Sabuncu
#

#from node import NodeType, Node

class Atom:
    
    def __init__(self,name,arity):
	self.name = name
	self.arity = arity
	self.inHead = []
	self.inBody = []
	
    def addToinHead(self,rule):
	self.inHead[len(self.inHead):] = [rule]
	
    def addToinBody(self,rule):
	self.inBody[len(self.inBody):] = [rule]
	
    
class Literal:
    
    def __init__(self,atom,naf,variables):
	self.atom = atom
	self.naf = naf
	self.vars = variables
	
    def tostrVars(self):
	str = ''
	for v in self.vars:
	    str += v[1] + ','
	return str[:-1]
	
    def toTPTPFormat(self):
	str = ''
	if (self.naf):
	    str += '~'
	
	if (self.atom.name == '==' or self.atom.name == '!='):
	    t = self.atom.name
	    if t == '==':
		t = '='
	    if (self.naf):
		if t == '=':
		    t = '!='
		elif t == '!=':
		    t = '='
	    str = self.vars[0][1]+t+self.vars[1][1]
	else:
	    str += self.atom.name
	    if (self.atom.arity != 0):
		str += '(' + self.tostrVars() + ')'
	return str
	
	
class Rule:
    
    def __init__(self):
	self.head = None
	self.body = []
	self.var_names = None
	self.is_constraint = False
	self.is_fact = False
    	
    def addToBody(self,lit):
	self.body[len(self.body):] = [lit]
	
    def headVariables(self):
	if (self.head):
	    return [arg for arg in self.head.vars if arg[0] == 'V']
	else:
	    return []
	
    def bodyVariables(self):
	if (self.body):
	    t = []
	    for bl in self.body:
		t[len(t):] = [arg for arg in bl.vars if arg[0] == 'V']
	    return t
	else:
	    return []
	

class AtomFactory:
    
    def __init__(self):
	self.atoms = {}
	
	
    def create(self,name,arity):
	if (self.atoms.has_key( (name,arity) )):
	    return self.atoms[ (name,arity) ]
	else:
	    a = Atom(name,arity)
	    self.atoms[ (name,arity) ] = a
	    return a
	
    def reset(self):
	self.atoms = {}

    '''
    Atoms with same name but different arities cause a problem in Paradox
    Differentiate the names using the arities
    atoms is a AtomFactory object
    '''
    def differentiateAtomsWithSameName(self):
        names = []
    
        for k,v in self.atoms.items():
	    if (k[0] not in names):
		names.append(k[0])
		continue
	    else:
		v.name = v.name+str(v.arity)
		newk = (v.name,v.arity)
		del self.atoms[k]
		self.atoms[newk] = v
		continue
    
    
'''
def createRule((head,body),atoms):
    r = Rule()
    
    if (not head):
	r.is_constraint = True
    else:
	assert head.type == NodeType.LITERAL
	tmp_vars = []
	for v in head.args:
	    if (v.type == NodeType.VARIABLE):
		tmp_vars[len(tmp_vars):] = [('V',v.val)]
	    elif (v.type == NodeType.NUMBER):
		tmp_vars[len(tmp_vars):] = [('O',v.val)]
	    elif (v.type == NodeType.LITERAL):
		# can be object or literal ???
		# may need evaluation
		tmp_vars[len(tmp_vars):] = [('O',v.val)]
            #elif (v.type == NodeType.EXPR):
		#tmp_vars.extend([('E',v.val)]
	    
	a = atoms.create(head.val, len(head.args))
	l = Literal(a,head.naf,tmp_vars)
	r.head = l
	a.addToinHead(r)
    
    if (not body):
	r.is_fact = True
	r.body = None
    else:
	# now process the body nodes
	for b in body:
	    assert b.type == NodeType.LITERAL
	    tmp_vars = []
	    for v in b.args:
		if (v.type == NodeType.VARIABLE):
                    tmp_vars[len(tmp_vars):] = [('V',v.val)]
		elif (v.type == NodeType.NUMBER):
                    tmp_vars[len(tmp_vars):] = [('O',v.val)]
		elif (v.type == NodeType.LITERAL):
                    # can be object or literal ???
                    # may need evaluation
                    tmp_vars[len(tmp_vars):] = [('O',v.val)]
		#elif (v.type == NodeType.EXPR):
                    #tmp_vars.extend([('E',v.val)]
	    
	    a = atoms.create(b.val, len(b.args))
	    l = Literal(a, b.naf, tmp_vars)
	    r.addToBody(l)
	    a.addToinBody(r)
    
    return r
'''
