#! /usr/bin/env python
#
# Completor
# main module
#
# Orkunt Sabuncu
#

import sys
import options
import parsing
import program
import completion
import uniquenames
import clausification
#import clausification_nodeepcopy as clausification
import domainclosure

cmdline = sys.argv[1:]

ret = options.options.parse_commandline(cmdline)
if ret != 0:
    sys.exit(1)

try:
    ptree = parsing.parse_file(options.options.infile, options.options.consts)
    prog = program.construct_program(ptree)
    comp_prog = completion.complete_program(prog)
    sorts_inf = uniquenames.infer_sorts(prog, program.program_atoms, program.program_objects)
    una = []
    clausified_prog = []
    clausified_una = []
    dca = None
    clausified_dca = None
    idx = 1
    
    if (options.options.una != 'None'):
	#sorts_inf = uniquenames.infer_sorts(prog, program.program_atoms, program.program_objects)
	sorts = sorts_inf[0].values()
	#for s in sorts:
	    #s.sort()
	una = uniquenames.generate_una(sorts)
	#print 'Sorts', sorts
	#print 'Una', una
    
    if (options.options.dca):
        dca = domainclosure.dca_axiom(program.program_objects)
    
    if (options.options.clausify != 'None'):
        if (options.options.clausify == 'Defskolem'):
            clausified_prog = reduce(lambda x,y: x + clausification.clausify_formula_definitional_withsko(y),comp_prog,[])
            if (len(una) > 0):
                clausified_una = reduce(lambda x,y: x + clausification.clausify_formula_definitional_withsko(y),una,[])
            if (dca):
                clausified_dca = clausification.clausify_formula_definitional_withsko(dca)[0]
        elif (options.options.clausify == 'Defnoskolem'):
            clausified_prog = reduce(lambda x,y: x + clausification.clausify_formula_definitional_withoutsko(y,sorts_inf),comp_prog,[])
            if (len(una) > 0):
                clausified_una = reduce(lambda x,y: x + clausification.clausify_formula_definitional_withoutsko(y,sorts_inf),una,[])
            if (dca):
                clausified_dca = clausification.clausify_formula_definitional_withoutsko(dca,sorts_inf)[0]
        elif (options.options.clausify == 'Skolem'):
	    clausified_prog = reduce(lambda x,y: x + clausification.clausify_formula_withsko(y),comp_prog,[])
	    if (len(una) > 0):
		clausified_una = reduce(lambda x,y: x + clausification.clausify_formula_withsko(y),una,[])
            if (dca):
                clausified_dca = clausification.clausify_formula_withsko(dca)[0]
	elif (options.options.clausify == 'Noskolem'):
	    clausified_prog = reduce(lambda x,y: x + clausification.clausify_formula_withoutsko(y,sorts_inf),comp_prog,[])
	    if (len(una) > 0):
		clausified_una = reduce(lambda x,y: x + clausification.clausify_formula_withoutsko(y,sorts_inf),una,[])
            if (dca):
                clausified_dca = clausification.clausify_formula_withoutsko(dca,sorts_inf)[0]
		
	# output clausified theory
	for cl in clausified_prog:
	    print clausification.clausetoTPTPFormat(cl,str(idx))
	    idx += 1
	    
        if (clausified_dca):
            print '\n%\n% domain closure axiom\n%'
            print clausification.clausetoTPTPFormat(clausified_dca,str(idx))
            idx += 1
            
	if (len(clausified_una) > 0):
            print '\n%\n% unique name axioms\n%'
	    for cl in clausified_una:
		print clausification.clausetoTPTPFormat(cl,str(idx))
		idx += 1
		
    else:
	for cf in comp_prog:
	    #cf.renameVars()
	    print cf.toTPTPFormat(str(idx))
	    idx += 1 
	
        if (dca):
            print '\n%\n% domain closure axiom\n%'
            print dca.toTPTPFormat(str(idx))
            idx += 1
        
	if (len(una) > 0):
	    print '\n%\n% unique name axioms\n%'
	    for f in una:
		print f.toTPTPFormat(str(idx))
		idx += 1
		    
except Exception, exp:
    #print >> sys.stderr, exp
    raise
