#
# Prepare the domain closure axiom
#
# Orkunt Sabuncu
#

from atomrule import *
from completion import CompletedFormula, CompletedPart

def dca_axiom(pobjects):
    dca = CompletedFormula()
    eq_a = Atom('==',2)
    varX = ('V','X')
    objs = pobjects.atoms.keys()
    
    dca.universal_vars.append(varX)
    
    tmp = []
    for o in objs:
        l = Literal(eq_a, True, [varX, ('O',o[0])])
        tmp.append(l)
        
    cp = CompletedPart([],tmp)
    dca.disj_part.append(cp)
    return dca
