#
# Lex file for the completor
# 
# Orkunt Sabuncu
#

tokens = (
	'IF',
	'NOT',
	'IDENTIFIER',
	'VARIABLE',
	'NUMBER',
#	'COMMENT',
	'COMMENT2',
	'WS',
	'EQ',
	'NEQ',	
	'DOTS',
        'EXP',
        'MOD',
        'LT',
        'LE',
        'GT',
        'GE',
        'ASSIGN'
)

literals = "(),.;|+-*/"

t_IF = r':-'
t_IDENTIFIER = r'-?[a-z_][a-zA-Z0-9_\']*'
t_VARIABLE = r'[A-Z][a-zA-Z0-9_]*'
t_NUMBER = r'[0-9][0-9]*'
t_EQ = r'=='
t_NEQ = r'!='
t_DOTS = r'\.\.'
t_EXP = r'\*\*'
t_MOD = r'[Mm][Oo][Dd]'
t_LT = r'<'
t_LE = r'<='
t_GT = r'>'
t_GE = r'>='
t_ASSIGN = r'='

def t_newline(t):
    r'\n+'
    t.lexer.lineno += len(t.value)

#t_ignore_COMMENT = r'%.*\n'
t_ignore_COMMENT2 = r'%.*'
t_ignore_WS = r'[\t\r ]'

def t_error(t):
    print "Illegal character '%s'" % t.value[0]
    t.lexer.skip(1)

def t_NOT(t):
    r'[Nn][Oo][Tt]'
    return t

	
