#
# Options
#
# Orkunt Sabuncu
#

'''
    a dict of flag descriptions
    (name, possible values, description, default value)
'''
flag_desc = { 'FL_CONSTS':('-c', '<const>=<value>', 'constant definition', {}),
              'FL_UNA':('-una', 'None|Naive|Nlogn', 'control unique names axiom', 'Naive'),
	      'FL_RN':('-rn','','rename number objects', False),
	      'FL_CLAUSIFY':('-clausify', 'None|Defskolem|Defnoskolem|Skolem|Noskolem', 'control clausification', 'None'),
	      'FL_UNSORTED':('-unsorted', '', 'program representation is unsorted', False),
              'FL_DCA':('-dca', '', 'add domain closure axiom', False)
            }

class Options:
    
    def __init__(self):
	self.consts = flag_desc['FL_CONSTS'][3]
	self.una = flag_desc['FL_UNA'][3]
	self.infile = ''
	self.rename_numbers = flag_desc['FL_RN'][3]
	self.clausify = flag_desc['FL_CLAUSIFY'][3]
	self.unsorted = flag_desc['FL_UNSORTED'][3]
        self.dca = flag_desc['FL_DCA'][3]
	
    def parse_commandline(self, argv):
	self.__init__()
	i = 0
	inf = ''

	while i<len(argv):
	    if (argv[i] == flag_desc['FL_CONSTS'][0]):
		try:
		    v = argv[i+1].split('=')
		    if (len(v) != 2):
			raise Exception
		    if (v[0] == ''):
			raise Exception
		    if (v[1] == ''):
			raise Exception
		    self.consts[v[0]] = v[1]
		    i += 2
		except:
                    print 'Command line error: %s %s' %(flag_desc['FL_CONSTS'][0], flag_desc['FL_CONSTS'][1])
                    return -1
	    elif (argv[i] == flag_desc['FL_UNA'][0]):
		try:
		    v = argv[i+1]
		    if not ((v == 'None') or (v == 'Naive') or (v == 'Nlogn')):
			raise Exception
		    self.una = v
		    i += 2
		except:
		    print 'Command line error: %s %s' %(flag_desc['FL_UNA'][0], flag_desc['FL_UNA'][1])
                    return -1
	    elif (argv[i] == flag_desc['FL_RN'][0]):
		self.rename_numbers = True
		i += 1
	    elif (argv[i] == flag_desc['FL_CLAUSIFY'][0]):
		try:
		    v = argv[i+1]
		    if not ((v == 'None') or (v == 'Defskolem') or (v == 'Defnoskolem') or (v == 'Skolem') or (v == 'Noskolem')):
			raise Exception
		    self.clausify = v
		    i += 2
		except:
		    print 'Command line error: %s %s' %(flag_desc['FL_CLAUSIFY'][0], flag_desc['FL_CLAUSIFY'][1])
                    return -1
	    elif (argv[i] == flag_desc['FL_UNSORTED'][0]):
		self.unsorted = True
		i += 1
            elif (argv[i] == flag_desc['FL_DCA'][0]):
		self.dca = True
		i += 1
	    else:
		try:
		    inf = argv[i]
		    if i+1 != len(argv):
			raise Exception
		    i += 1
		except:
		    print 'Command line error: only one input file is allowed at the end'
		    return -1
		
	if inf == '':
	    print 'Command line error: no input file'
	    return -1
	
	self.infile = inf
	return 0

options = Options()
		
		    
