# 
# Parsing module
#

import ply.lex as lex
import ply.yacc as yacc

import lexer
import grammer
import node

lex.lex(module=lexer)
yacc.yacc(module=grammer)

def first_parse(str):
    return yacc.parse(str)

def second_parse(str):
    grammer.atomfactory.reset()
    return yacc.parse(str)

'''
    Parses a file.
    returns list of rules [(head,[body])]
'''
def parse_file(filename, consts):
    f = open(filename, 'r')
    t = f.read()
    f.close()
    
    ptree1 = first_parse(t)
    
    t2 = node.secondPhaseParsing(ptree1, grammer.atomfactory, filename, consts)
    if (t2 != ''):
	ptree2 = second_parse(t2)
	ptree = ptree2
    else:
	ptree = ptree1

    # expanding...
    return reduce(lambda x,y: x + node.expandRule(y[0],consts), ptree, [])

'''
    Parses string
    returns list of rules [(head,[body])]
'''
def parse_string(str, consts):
    ptree1 = first_parse(str)
    
    t2 = node.secondPhaseParsing(ptree1, grammer.atomfactory, 'fromstr', consts)
    if (t2 != ''):
	ptree2 = second_parse(t2)
	ptree = ptree2
    else:
	ptree = ptree1

    # expanding...
    return reduce(lambda x,y: x + node.expandRule(y[0],consts), ptree, [])

